/********************************************************************************/
/* Programm	: MXFROMSQ.CMD							*/
/* Zweck	: Alle Squish - Areas suchen und Echoarea.ctl schreiben		*/
/* Autor	: Thomas Mller							*/
/* EMail	: 2:2454/117@Fidonet,						*/
/*		  23:700/3@Kultnet						*/
/*		  70:7101/440@VPLNet						*/
/*		  142:1011/55@SFNet						*/
/* Erstellt     : 15.19.1995							*/
/* Nach einer Idee von: Lutz Buchheister  / Dieter Rautenstengel / Ralph Theren	*/
/*------------------------------------------------------------------------------*/
/* Beschreibung	: Es werden alle Echoareas aus der Squish.Cfg ausgelesen	*/
/*		  und daraus eine Echoarea.Ctl fr Maximus erzeugt.		*/
/*		  Dabei knnen Areas zu Gruppen zusammengefat werden.		*/
/*		  Areabeschreibungen werden aus einem externen File gelesen.	*/
/*------------------------------------------------------------------------------*/
/* Installation	: In der MSGAREA.CTL werden nur noch lokale und die Netmail	*/
/*		  Am Ende der MSGAREA.CTL wird dann noch die Zeile		*/
/*			INCLUDE ECHOAREA.CTL					*/
/*		  angehaengt.							*/
/*------------------------------------------------------------------------------*/
/* History	: 19.03.95  1.00 erste Version					*/
/*		  19.08.95  1.10 an Maximus 3.0 angepat			*/
/*				 (nicht mehr fr 2.x verwenden!!) 		*/
/********************************************************************************/

CALL RXFUNCADD 'SYSLOADFUNCS','REXXUTIL','SYSLOADFUNCS'
CALL SYSLOADFUNCS

CALL SysCurState OFF

Header.1 = '͸'
Header.2 = '     MAX from SQUISH MSG-Areaconverter                        Version 1.10   '
Header.3 = '                                                                             '
Header.4 = '     (c) 1995 by Thomas Mueller, 2:2454/117@Fidonet                          '
Header.5 = '                                                                             '
Header.6 = ' nach einer Idee von Lutz Buchheister, Ralph Theren und Dieter Rautenstengel '
Header.7 = ';'
Header.0 = 7

CALL SysCLS
Do i = 1 To Header.0
  SAY Header.i
END

PARSE arg config

IF LENGTH(config) = 0 THEN DO
  config='mxfromsq.Cfg'
END
SAY 'ConfigFile: 'config

/* SAY 'config='config */

CALL SysFileTree config,'file','F'
IF file.0 = 0 THEN Do
  SAY "Die Konfigurationsdatei wurde nicht gefunden!"
  Exit
END

MaxLevel.1  = TRANSLATE('Transient')
MaxLevel.2  = TRANSLATE('Disgrace')
MaxLevel.3  = TRANSLATE('Limited')
MaxLevel.4  = TRANSLATE('Normal')
MaxLevel.5  = TRANSLATE('Worthy')
MaxLevel.6  = TRANSLATE('Privil')
MaxLevel.7  = TRANSLATE('Favored')
MaxLevel.8  = TRANSLATE('Extra')
MaxLevel.9  = TRANSLATE('Clerk')
MaxLevel.10 = TRANSLATE('AsstSysop')
MaxLevel.11 = TRANSLATE('Sysop')
MaxLevel.12 = TRANSLATE('Hidden')
MaxLevel.0  = 12

LogLevelChars.1 = '#'
LogLevelChars.2 = ':'
LogLevelChars.3 = '+'
LogLevelChars.4 = '!'

speztag = 0
OutFile = ''
StartNo=0
SquishCfg=''
LogFile = ''
DescFile = ''
readlevel=''
writelevel=''
DefaultKeys=''
GroupCount = 0

Line = 0
DO UNTIL LINES(config)=0
  inline = TRANSLATE(Strip(Linein(config)),' ',d2c(09))
  Line = Line + 1
  IF (SUBSTR(inline,1,1) <> ";") & (LENGTH(inline) > 0) THEN Do
    PARSE UPPER VAR inline Keyword Value Rest
    SELECT
      WHEN Keyword = 'OUTFILE' THEN do
        OutFile = Value
        CALL SysCurPos Header.0+1,0
        SAY 'OutFile: 'OutFile
      END
      WHEN Keyword = 'SQUISHCFG' THEN do
        SquishCfg = Value
        CALL SysCurPos Header.0+2,0
        SAY 'SquishCfg: 'SquishCfg
      END
      WHEN Keyword = 'LOGFILE' THEN do
        LogFile = Value
        CALL SysCurPos Header.0+3,0
        SAY 'LogFile: 'LogFile
      END
      WHEN Keyword = 'DESCFILE' THEN do
        DescFile = Value
        CALL SysCurPos Header.0+4,0
        SAY 'DescFile: 'DescFile
      END
      WHEN Keyword='GROUP' THEN do
        GroupCount = GroupCount + 1
        CALL SysCurPos Header.0+5,0
        CALL ReadGroup Value, GroupCount
      END
      Otherwise
        SAY 'Fehler im Config-File, Zeile 'Line': 'inline
        Exit
    END /* SELECT */
  END /* IF */
END /* do until */
ok = STREAM(config,c,'close')

IF Outfile = '' THEN DO
  SAY 'Config-Fehler: Keine Ausgabedatei angegeben (OUTFILE).'
  EXIT
END
IF SquishCfg='' THEN DO
  SAY 'Config-Fehler: SQUISH.CFG nicht angegeben (SQUISHCFG).'
  EXIT
END
IF LogFile = '' THEN DO
  SAY 'Config-Fehler: Kein Log-File angegeben (LOGFILE).'
  EXIT
END
IF DescFile = '' THEN DO
  SAY 'Config-Fehler: Keine Description-Datei angegeben (DESCFILE).'
  EXIT
END

CALL WriteLog 3,'Start, Max from Squish 1.10'

DO i = Header.0 TO 24
  CALL SysCurPos i,0
  CALL CHAROUT ,COPIES(' ',79)
END
CALL SysCurPos Header.0,0

DO i = 1 TO GroupCount-1			/* Nicht gesetzte Gruppenwerte auf Default */
  IF ReadLevel.i = 0 THEN DO
    ReadLevel.i = ReadLevel.GroupCount
    SAY 'ReadLevel von Gruppe 'Groupname.i' auf Default ('Zahl2Maxlevel(ReadLevel.i)') gesetzt.'
    CALL WriteLog 2,'ReadLevel of group 'Groupname.i' set to default ('Zahl2Maxlevel(ReadLevel.i)')'
  END
  IF WriteLevel.i = 0 THEN DO
    WriteLevel.i = WriteLevel.GroupCount
    SAY 'WriteLevel von Gruppe 'Groupname.i' auf Default ('Zahl2Maxlevel(WriteLevel.i)') gesetzt.'
    CALL WriteLog 2,'WriteLevel of group 'Groupname.i' set to default ('Zahl2Maxlevel(WriteLevel.i)')'
  END
  IF Origin.i = '' THEN DO
    Origin.i = Origin.GroupCount
    SAY 'Origin von Gruppe 'Groupname.i' auf Default ('Origin.i') gesetzt.'
    CALL WriteLog 2,'Origin of group 'Groupname.i' set to default ('Origin.i')'
  END
END

CALL SysCLS
Do i = 1 To Header.0
  SAY Header.i
END

CALL SysCurPos Header.0,0

CALL SysFileTree DescFile,'file','F'
IF file.0 = 0 THEN Do
  SAY "Die Datei "'DescFile'" wurde nicht gefunden!"
  Exit
END

rc = SysFileSearch('EchoArea ', squishcfg, area)
IF rc <> 0 THEN DO
  SAY 'Fehler beim Versuch die Datei 'squishcfg' einzulesen. ABBRUCH!'
  SAY 'Haben Sie den Parameter SQUISHCFG in der *.CFG korrekt definiert?'
  Exit
END

SAY "Generating ECHOAREA.CTL ...  "
SAY " "
SAY "Compiling ...                "

CALL SysFileDelete(outfile) 	                        /* altes File lschen */
CALL LINEOUT outfile,'% created at 'Date() Time()	/* Fileheader schreiben */
DO i = 1 TO Header.0
  CALL LINEOUT '%' outfile,Header.i
END
CALL LINEOUT outfile,'%'

DO anzahl = 1 TO area.0
  /* In Grossbuchstaben und Tabs in Leerzeichen wandeln */
  Zeile = TRANSLATE(TRANSLATE(area.anzahl,' ',d2c(09)))
  IF Subword(Zeile,1,1) = "ECHOAREA" THEN DO
    PARSE UPPER VAR Zeile Dummy AreaTag Areapath Rest
    CALL SysCurPos Header.0+1,0
    AreaZone = 0
    AreaType = '*.MSG'
    PARSE VAR Rest Wort Rest
    PassThru = 0
    DO UNTIL (SUBSTR(Wort,1,1) <> '-') | PassThru
      Flag = SUBSTR(Wort,2,1)
      SELECT
        WHEN Flag = '0' THEN /* passthru */
          PassThru = 1
        WHEN Flag = '$' THEN
          AreaType = 'SQUISH'
        WHEN Flag = 'P' THEN
          AreaZone = SUBWORD(TRANSLATE(Wort,'   ','-P:'),1,1)
        OTHERWISE
          NOP
      END /* SELECT */
      PARSE VAR Rest Wort Rest
    END
    IF PassThru THEN
      ITERATE

    Group=-1
    DO i = 1 TO GroupCount UNTIL Group<>-1
      DO j = 1 TO GroupAreas.i.0 UNTIl Group<>-1
        IF MatchAreatag(GroupAreas.i.j,AreaTag) THEN
          Group = i
      END
      IF Group = -1 THEN
        IF AreaZone<>0 THEN
          IF AreaZone=Zone.i THEN
            Group=i
    END
    IF Group = -1 THEN DO
      SAY 'Fehler: Keine Gruppe fr Area 'AreaTag' gefunden'
      CALL WriteLog 4,'No group found for area 'AreaTag
      ITERATE
    END

    IF ReadLevel.Group=MaxLevel.0 THEN /* Hidden, nicht einbinden */
      ITERATE

    CALL SysFileSearch AreaTag,DescFile,'Desc'
    AreaDesc = ''
    DO i = 1 TO Desc.0
      IF AreaTag = SUBWORD(TRANSLATE(Desc.i,' ',d2c(09)),1,1) THEN DO
        AreaDesc = SUBWORD(TRANSLATE(Desc.i,' ',d2c(09)),2)' ('AreaTag')'
        LEAVE
      END
    END
    IF AreaDesc = '' THEN DO
      AreaDesc = AreaTag
      CALL WriteLog 3,'No description 'AreaTag
    END

    SAY AreaTag'                      '
    SAY 'AreaType 'AreaType' '
    IF AreaZone=0 THEN
      SAY 'Zone=default      '
    ELSE
      SAY 'Zone='AreaZone'      '
    IF Group<>-1 THEN
      SAY 'Gruppe 'GroupName.Group'                    '
    ELSE
      SAY 'Gruppe keine                  '
    SAY 'Beschreibung: 'AreaDesc||COPIES(' ',80-4-LENGTH(AreaDesc))

    AreaNo = StartNo.Group
    AreaReadlevel = ReadLevel.Group
    AreaKeys = Keys.Group
    AreaWritelevel = WriteLevel.Group
    AreaOrigin = Origin.Group

    StartNo.Group = AreaNo+1

    CALL LINEOUT outfile,'MsgArea 'AreaNo
    IF AreaKeys <> '' THEN
      CALL LINEOUT outfile,'  ACS          'Zahl2MaxLevel(AreaReadLevel)'/'AreaKeys
    ELSE
      CALL LINEOUT outfile,'  ACS          'Zahl2MaxLevel(AreaReadLevel)
    CALL LINEOUT outfile,'  Style        'AreaType' Echo Pub'
    CALL LINEOUT outfile,'  Tag          'AreaTag
    CALL LINEOUT outfile,'  Desc         'AreaDesc
    CALL LINEOUT outfile,'  path         'AreaPath

    IF LENGTH(AreaOrigin)>0 THEN
      CALL LINEOUT outfile,'  Origin 'AreaOrigin

    IF AreaReadLevel <> WriteLevel THEN Do
      CALL LINEOUT outfile,'  Override     MESSAGE Msg_Enter 'MaxLevel.AreaWritelevel
      CALL LINEOUT outfile,'  Override     MESSAGE Msg_Reply 'MaxLevel.AreaWriteLevel
      CALL LINEOUT outfile,'  Override     MESSAGE Msg_Change 'MaxLevel.AreaWriteLevel
    END

    CALL LINEOUT outfile,'End Area'
    CALL LINEOUT outfile,'%'

  END /* IF */
END /* DO */

Signal Ende

Fehler:
CALL WriteLog 4,'Error processing area 'AreaTag
Signal Ende

ENDE:
SAY " "
SAY "Das war's ..."
CALL WriteLog 3,'End, Max from Squish 1.10'
CALL LINEOUT Logfile
CALL LINEOUT outfile           /* Ausgabefile schliessen */

cs = SysCurState(On)
CALL SysDropFuncs
Return

/* Prozeduren */

/* liest eine komplette Gruppe aus dem Config-File */
ReadGroup: PROCEDURE EXPOSE Config Line GroupName. GroupAreas. StartNo. Origin. Keys. Zone. ReadLevel. WriteLevel. Maxlevel.
  ARG Group, idx

  i=0
  PARSE VALUE SysCurPos() WITH Zeile Spalte
  AreaZeile = Zeile+2
  AreaSpalte = 7

  StartNo.idx = 0
  Origin.idx = ''
  Keys.idx=''
  Zone.idx=0
  ReadLevel.idx=0
  WriteLevel.idx=0

  GroupName.idx = Group

  SAY 'Gruppe    Zone Strt Keys      Read      Write     Origin'
  SAY Group||COPIES(' ',79-LENGTH(Group))
  SAY 'Areas:'COPIES(' ',79-6-LENGTH(Group))
  DO z=AreaZeile+1 TO 24
    CALL SysCurPos z,0
    CALL CHAROUT ,COPIES(' ',79)
  END

  DO UNTIL Keyword = 'END' | LINES(config)=0
    inline = TRANSLATE(STRIP(LINEIN(config)),' ',D2C(09))
    Line = Line + 1
    IF (SUBSTR(inline,1,1) <> ";") & (LENGTH(inline) > 0) THEN DO
      PARSE UPPER VAR inline Keyword Value Rest
      SELECT
        WHEN Keyword = 'AREA' THEN DO
          i = i + 1
          GroupAreas.idx.i = Value
          Spalte = AreaSpalte + LENGTH(Value) + 1
          IF Spalte>79 THEN DO
            AreaZeile = AreaZeile + 1
            Spalte = LENGTH(Value) +1
            AreaSpalte = 0
          END
          CALL SysCurPos AreaZeile,AreaSpalte
          CALL CHAROUT ,Value
          AreaSpalte = Spalte
        END
        WHEN Keyword = 'ZONE' THEN DO
          Zone.idx = Value
          CALL SysCurPos Zeile+1,10
          CALL CHAROUT , Zone.idx
        END
        WHEN Keyword = 'STARTNO' THEN DO
          StartNo.idx = Value
          CALL SysCurPos Zeile+1,15
          CALL CHAROUT , StartNo.idx
        END
        WHEN Keyword = 'KEYS' THEN DO
          Keys.idx = Value
          CALL SysCurPos Zeile+1,20
          CALL CHAROUT , Keys.idx
        END
        WHEN Keyword = 'READLEVEL' THEN DO
          ReadLevel.idx = Maxlevel2Zahl(Value)
          CALL SysCurPos Zeile+1,30
          CALL CHAROUT , Zahl2Maxlevel(ReadLevel.idx)
        END
        WHEN Keyword = 'WRITELEVEL' THEN DO
          WriteLevel.idx = Maxlevel2Zahl(Value)
          CALL SysCurPos Zeile+1,40
          CALL CHAROUT , idx'='Zahl2Maxlevel(WriteLevel.idx)
        END
        WHEN Keyword = 'ORIGIN' THEN DO
          Origin.idx = Value' 'Rest
          CALL SysCurPos Zeile+1,50
          CALL CHAROUT , SUBSTR(Origin.idx,1,30)
        END
        WHEN Keyword = 'END' THEN
          NOP
      OTHERWISE
        SAY 'Fehler im Config-File, Zeile 'Line': 'inline
      END /* SELECT */
    END /* IF */
  END /* DO FOREVER */
  GroupAreas.idx.0 = i
  IF WriteLevel.idx = 0 THEN
    WriteLevel.idx = ReadLevel.idx
RETURN

Maxlevel2Zahl: PROCEDURE EXPOSE Maxlevel.
  Arg Level
  DO j = 1 TO Maxlevel.0
    IF Maxlevel.j = Level THEN
      LEAVE
  END
RETURN j

Zahl2Maxlevel: PROCEDURE EXPOSE Maxlevel.
  Arg Level
RETURN Maxlevel.Level

/* In Match ist nur ein * erlaubt, */
/* der entweder am Anfang oder am Ende stehen mu */
MatchAreatag: PROCEDURE
  ARG Match,Tag

  p = POS('*',Match)
  l = LENGTH(Match)
  SELECT 
    WHEN p=0 THEN
      NOP
    WHEN p=1 THEN DO
      Tag = SUBSTR(REVERSE(Tag),1,l-1)
      Match = REVERSE(SUBSTR(Match,2))
    END
    WHEN p = l THEN DO
      Tag = SUBSTR(Tag,1,l-1)
      Match = SUBSTR(Match,1,l-1)
    END
    OTHERWISE
      SAY 'Fehlerhafter Match 'Match
      SAY 'Der * mu am Anfang oder Ende stehen.'
      Exit
  END /* SELECT */
RETURN (Tag = Match)

WriteLog: PROCEDURE EXPOSE Logfile LoglevelChars.
  PARSE ARG Loglevel,Zeile
  
  CALL LINEOUT Logfile,LoglevelChars.Loglevel SUBWORD(Date(),1,2) Time() 'MXSQ' Zeile
RETURN
